{{#withSeparateModelsAndApi}}
    /* tslint:disable */
    /* eslint-disable */
    {{>licenseInfo}}

    import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
    import { Configuration } from '{{apiRelativeToRoot}}configuration';
    // Some imports not used depending on template conditions
    // @ts-ignore
    import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '{{apiRelativeToRoot}}base';
    {{#imports}}
        // @ts-ignore
        import { {{classname}} } from '{{apiRelativeToRoot}}{{tsModelPackage}}';
    {{/imports}}

    function flatten(obj: any) {
    const res = {};
    flatten_h(obj, '', res);
    return res;
    }

    function flatten_h(obj: any, prefix: string, res: any) {
    for (let x of Object.keys(obj)) {
    let key = x;
    if (prefix != '') {
    key = prefix + '.' + x;
    }

    if (isDict(obj[x])) {
    flatten_h(obj[x], key, res);
    } else {
    res[key] = obj[x];
    }
    }
    }

    function isDict(obj: any): boolean {
    return obj.constructor == Object;
    }

{{/withSeparateModelsAndApi}}
{{^withSeparateModelsAndApi}}
{{/withSeparateModelsAndApi}}
{{#operations}}
    /**
    * {{classname}} - axios parameter creator{{#description}}
        * {{&description}}{{/description}}
    * @export
    */
    export const {{classname}}AxiosParamCreator = function (configuration?: Configuration) {
    return {
    {{#operation}}
        /**
        * {{&notes}}
        {{#summary}}
            * @summary {{&summary}}
        {{/summary}}
        {{#allParams}}
            * @param {{=<% %>=}}{<%&dataType%>}<%={{ }}=%> {{^required}}[{{/required}}{{paramName}}{{^required}}]{{/required}} {{description}}
        {{/allParams}}
        * @param {*} [options] Override http request option.
        * @throws {RequiredError}
        */
        {{nickname}}: async ({{#allParams}}{{paramName}}{{^required}}?{{/required}}: {{{dataType}}}, {{/allParams}}options: any = {}): Promise<RequestArgs> => {
        {{#allParams}}
            {{#required}}
                    // verify required parameter '{{paramName}}' is not null or undefined
                    if ({{paramName}} === null || {{paramName}} === undefined) {
                    throw new RequiredError('{{paramName}}','Required parameter {{paramName}} was null or undefined when calling {{nickname}}.');
                    }
            {{/required}}
        {{/allParams}}
            const localVarPath = `{{{path}}}`{{#pathParams}}
                .replace(`{${"{{baseName}}"}}`, encodeURIComponent(String({{paramName}}))){{/pathParams}};
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
            baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: '{{httpMethod}}', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;{{#vendorExtensions}}{{#hasFormParams}}
                const localVarFormParams = new {{^multipartFormData}}URLSearchParams(){{/multipartFormData}}{{#multipartFormData}}((configuration && configuration.formDataCtor) || FormData)(){{/multipartFormData}};{{/hasFormParams}}{{/vendorExtensions}}

        {{#authMethods}}
                // authentication {{name}} required
            {{#isApiKey}}
                {{#isKeyInHeader}}
                        if (configuration && configuration.apiKey) {
                        const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                        ? await configuration.apiKey("{{keyParamName}}")
                        : await configuration.apiKey;
                        localVarHeaderParameter["{{keyParamName}}"] = localVarApiKeyValue;
                        }
                {{/isKeyInHeader}}
                {{#isKeyInQuery}}
                        if (configuration && configuration.apiKey) {
                        const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                        ? await configuration.apiKey("{{keyParamName}}")
                        : await configuration.apiKey;
                        localVarQueryParameter["{{keyParamName}}"] = localVarApiKeyValue;
                        }
                {{/isKeyInQuery}}
            {{/isApiKey}}
            {{#isBasicBasic}}
                    // http basic authentication required
                    if (configuration && (configuration.username || configuration.password)) {
                    localVarRequestOptions["auth"] = { username: configuration.username, password: configuration.password };
                    }
            {{/isBasicBasic}}
            {{#isBasicBearer}}
                    // http bearer authentication required
                    if (configuration && configuration.accessToken) {
                    const accessToken = typeof configuration.accessToken === 'function'
                    ? await configuration.accessToken()
                    : await configuration.accessToken;
                    localVarHeaderParameter["Authorization"] = "Bearer " + accessToken;
                    }
            {{/isBasicBearer}}
            {{#isOAuth}}
                    // oauth required
                    if (configuration && configuration.accessToken) {
                    const localVarAccessTokenValue = typeof configuration.accessToken === 'function'
                    ? await configuration.accessToken("{{name}}", [{{#scopes}}"{{{scope}}}"{{^-last}}, {{/-last}}{{/scopes}}])
                    : await configuration.accessToken;
                    localVarHeaderParameter["Authorization"] = "Bearer " + localVarAccessTokenValue;
                    }
            {{/isOAuth}}

        {{/authMethods}}
        {{#queryParams}}
            {{#isArray}}
                    if ({{paramName}}) {
                {{#isCollectionFormatMulti}}
                    {{#uniqueItems}}
                            localVarQueryParameter['{{baseName}}'] = Array.from({{paramName}});
                    {{/uniqueItems}}
                    {{^uniqueItems}}
                            localVarQueryParameter['{{baseName}}'] = {{paramName}};
                    {{/uniqueItems}}
                {{/isCollectionFormatMulti}}
                {{^isCollectionFormatMulti}}
                    {{#uniqueItems}}
                            localVarQueryParameter['{{baseName}}'] = Array.from({{paramName}}).join(COLLECTION_FORMATS.{{collectionFormat}});
                    {{/uniqueItems}}
                    {{^uniqueItems}}
                            localVarQueryParameter['{{baseName}}'] = {{paramName}}.join(COLLECTION_FORMATS.{{collectionFormat}});
                    {{/uniqueItems}}
                {{/isCollectionFormatMulti}}
                    }
            {{/isArray}}
            {{^isArray}}
                    if ({{paramName}} !== undefined) {
                {{#isDateTime}}
                        localVarQueryParameter['{{baseName}}'] = ({{paramName}} as any instanceof Date) ?
                        ({{paramName}} as any).toISOString() :
                    {{paramName}};
                {{/isDateTime}}
                {{^isDateTime}}
                    {{#isDate}}
                            localVarQueryParameter['{{baseName}}'] = ({{paramName}} as any instanceof Date) ?
                            ({{paramName}} as any).toISOString().substr(0,10) :
                        {{paramName}};
                    {{/isDate}}
                    {{#isExplode}}
                        {{#isModel}}
                                for (const [key, value] of Object.entries(flatten({{paramName}}))) {
                                localVarQueryParameter[key] = value;
                                }

                        {{/isModel}}
                        {{#isPrimitiveType}}
                                localVarQueryParameter['{{baseName}}'] = {{paramName}};
                        {{/isPrimitiveType}}
                    {{/isExplode}}
                    {{^isExplode}}
                            localVarQueryParameter['{{baseName}}'] = {{paramName}};
                    {{/isExplode}}
                {{/isDateTime}}
                    }
            {{/isArray}}

        {{/queryParams}}
        {{#headerParams}}
            {{#isArray}}
                    if ({{paramName}}) {
                {{#uniqueItems}}
                        let mapped = Array.from({{paramName}}).map(value => (<any>"{{{dataType}}}" !== "Set<string>") ? JSON.stringify(value) : (value || ""));
                {{/uniqueItems}}
                {{^uniqueItems}}
                        let mapped = {{paramName}}.map(value => (<any>"{{{dataType}}}" !== "Array<string>") ? JSON.stringify(value) : (value || ""));
                {{/uniqueItems}}
                    localVarHeaderParameter['{{baseName}}'] = mapped.join(COLLECTION_FORMATS["{{collectionFormat}}"]);
                    }
            {{/isArray}}
            {{^isArray}}
                    if ({{paramName}} !== undefined && {{paramName}} !== null) {
                {{#isString}}
                        localVarHeaderParameter['{{baseName}}'] = String({{paramName}});
                {{/isString}}
                {{^isString}}
                        localVarHeaderParameter['{{baseName}}'] = String(JSON.stringify({{paramName}}));
                {{/isString}}
                    }
            {{/isArray}}

        {{/headerParams}}
        {{#vendorExtensions}}
            {{#formParams}}
                {{#isArray}}
                        if ({{paramName}}) {
                    {{#isCollectionFormatMulti}}
                        {{paramName}}.forEach((element) => {
                            localVarFormParams.{{#multipartFormData}}append{{/multipartFormData}}{{^multipartFormData}}set{{/multipartFormData}}('{{baseName}}', element as any);
                            })
                    {{/isCollectionFormatMulti}}
                    {{^isCollectionFormatMulti}}
                            localVarFormParams.{{#multipartFormData}}append{{/multipartFormData}}{{^multipartFormData}}set{{/multipartFormData}}({{paramName}}.join(COLLECTION_FORMATS.{{collectionFormat}}));
                    {{/isCollectionFormatMulti}}
                        }{{/isArray}}
                {{^isArray}}
                        if ({{paramName}} !== undefined) { {{^multipartFormData}}
                            localVarFormParams.set('{{baseName}}', {{paramName}} as any);{{/multipartFormData}}{{#multipartFormData}}{{#isPrimitiveType}}
                            localVarFormParams.append('{{baseName}}', {{paramName}} as any);{{/isPrimitiveType}}{{^isPrimitiveType}}
                            localVarFormParams.append('{{baseName}}', new Blob([JSON.stringify({{paramName}})], { type: "application/json", }));{{/isPrimitiveType}}{{/multipartFormData}}
                        }{{/isArray}}
            {{/formParams}}{{/vendorExtensions}}
        {{#vendorExtensions}}{{#hasFormParams}}{{^multipartFormData}}
                localVarHeaderParameter['Content-Type'] = 'application/x-www-form-urlencoded';{{/multipartFormData}}{{#multipartFormData}}
                localVarHeaderParameter['Content-Type'] = 'multipart/form-data';{{/multipartFormData}}
        {{/hasFormParams}}{{/vendorExtensions}}
        {{#bodyParam}}
            {{^consumes}}
                    localVarHeaderParameter['Content-Type'] = 'application/json';
            {{/consumes}}
            {{#consumes.0}}
                    localVarHeaderParameter['Content-Type'] = '{{{mediaType}}}';
            {{/consumes.0}}

        {{/bodyParam}}
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
            queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
            queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
        {{#hasFormParams}}
                localVarRequestOptions.data = localVarFormParams{{#vendorExtensions}}{{^multipartFormData}}.toString(){{/multipartFormData}}{{/vendorExtensions}};
        {{/hasFormParams}}
        {{#bodyParam}}
                const nonString = typeof {{paramName}} !== 'string';
                const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
                localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify({{paramName}} !== undefined ? {{paramName}} : {})
                : ({{paramName}} || "");
        {{/bodyParam}}

            return {
            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
            options: localVarRequestOptions,
            };
            },
    {{/operation}}
        }
        };

        /**
        * {{classname}} - functional programming interface{{#description}}
            * {{{description}}}{{/description}}
        * @export
        */
        export const {{classname}}Fp = function(configuration?: Configuration) {
        return {
    {{#operation}}
            /**
            * {{&notes}}
        {{#summary}}
                * @summary {{&summary}}
        {{/summary}}
        {{#allParams}}
                * @param {{=<% %>=}}{<%&dataType%>}<%={{ }}=%> {{^required}}[{{/required}}{{paramName}}{{^required}}]{{/required}} {{description}}
        {{/allParams}}
            * @param {*} [options] Override http request option.
            * @throws {RequiredError}
            */
            async {{nickname}}({{#allParams}}{{paramName}}{{^required}}?{{/required}}: {{{dataType}}}, {{/allParams}}options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<{{#returnType}}{{{returnType}}}{{/returnType}}{{^returnType}}void{{/returnType}}>> {
            const localVarAxiosArgs = await {{classname}}AxiosParamCreator(configuration).{{nickname}}({{#allParams}}{{paramName}}, {{/allParams}}options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
            const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
            return axios.request(axiosRequestArgs);
            };
            },
    {{/operation}}
        }
        };

        /**
        * {{classname}} - factory interface{{#description}}
            * {{&description}}{{/description}}
        * @export
        */
        export const {{classname}}Factory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
        return {
    {{#operation}}
            /**
            * {{&notes}}
        {{#summary}}
                * @summary {{&summary}}
        {{/summary}}
        {{#allParams}}
                * @param {{=<% %>=}}{<%&dataType%>}<%={{ }}=%> {{^required}}[{{/required}}{{paramName}}{{^required}}]{{/required}} {{description}}
        {{/allParams}}
            * @param {*} [options] Override http request option.
            * @throws {RequiredError}
            */
        {{nickname}}({{#allParams}}{{paramName}}{{^required}}?{{/required}}: {{{dataType}}}, {{/allParams}}options?: any): AxiosPromise<{{#returnType}}{{{returnType}}}{{/returnType}}{{^returnType}}void{{/returnType}}> {
            return {{classname}}Fp(configuration).{{nickname}}({{#allParams}}{{paramName}}, {{/allParams}}options).then((request) => request(axios, basePath));
            },
    {{/operation}}
        };
        };

    {{#withInterfaces}}
            /**
            * {{classname}} - interface{{#description}}
                * {{&description}}{{/description}}
            * @export
            * @interface {{classname}}
            */
            export interface {{classname}}Interface {
        {{#operation}}
                /**
                * {{&notes}}
            {{#summary}}
                    * @summary {{&summary}}
            {{/summary}}
            {{#allParams}}
                    * @param {{=<% %>=}}{<%&dataType%>}<%={{ }}=%> {{^required}}[{{/required}}{{paramName}}{{^required}}]{{/required}} {{description}}
            {{/allParams}}
                * @param {*} [options] Override http request option.
                * @throws {RequiredError}
                * @memberof {{classname}}Interface
                */
            {{nickname}}({{#allParams}}{{paramName}}{{^required}}?{{/required}}: {{{dataType}}}, {{/allParams}}options?: any): AxiosPromise<{{#returnType}}{{{returnType}}}{{/returnType}}{{^returnType}}void{{/returnType}}>;

        {{/operation}}
            }

    {{/withInterfaces}}
    {{#useSingleRequestParameter}}
        {{#operation}}
            {{#allParams.0}}
                    /**
                    * Request parameters for {{nickname}} operation in {{classname}}.
                    * @export
                    * @interface {{classname}}{{operationIdCamelCase}}Request
                    */
                    export interface {{classname}}{{operationIdCamelCase}}Request {
                {{#allParams}}
                        /**
                        * {{description}}
                        * @type {{=<% %>=}}{<%&dataType%>}<%={{ }}=%>
                        * @memberof {{classname}}{{operationIdCamelCase}}
                        */
                        readonly {{paramName}}{{^required}}?{{/required}}: {{{dataType}}}
                    {{^-last}}

                    {{/-last}}
                {{/allParams}}
                    }

            {{/allParams.0}}
        {{/operation}}
    {{/useSingleRequestParameter}}
        /**
        * {{classname}} - object-oriented interface{{#description}}
            * {{{description}}}{{/description}}
        * @export
        * @class {{classname}}
        * @extends {BaseAPI}
        */
    {{#withInterfaces}}
            export class {{classname}} extends BaseAPI implements {{classname}}Interface {
    {{/withInterfaces}}
    {{^withInterfaces}}
            export class {{classname}} extends BaseAPI {
    {{/withInterfaces}}
    {{#operation}}
            /**
            * {{&notes}}
        {{#summary}}
                * @summary {{&summary}}
        {{/summary}}
        {{#useSingleRequestParameter}}
            {{#allParams.0}}
                    * @param {{=<% %>=}}{<%& classname %><%& operationIdCamelCase %>Request}<%={{ }}=%> requestParameters Request parameters.
            {{/allParams.0}}
        {{/useSingleRequestParameter}}
        {{^useSingleRequestParameter}}
            {{#allParams}}
                    * @param {{=<% %>=}}{<%&dataType%>}<%={{ }}=%> {{^required}}[{{/required}}{{paramName}}{{^required}}]{{/required}} {{description}}
            {{/allParams}}
        {{/useSingleRequestParameter}}
            * @param {*} [options] Override http request option.
            * @throws {RequiredError}
            * @memberof {{classname}}
            */
        {{#useSingleRequestParameter}}
                public {{nickname}}({{#allParams.0}}requestParameters: {{classname}}{{operationIdCamelCase}}Request{{^hasRequiredParams}} = {}{{/hasRequiredParams}}, {{/allParams.0}}options?: any) {
                return {{classname}}Fp(this.configuration).{{nickname}}({{#allParams.0}}{{#allParams}}requestParameters.{{paramName}}, {{/allParams}}{{/allParams.0}}options).then((request) => request(this.axios, this.basePath));
                }
        {{/useSingleRequestParameter}}
        {{^useSingleRequestParameter}}
                public {{nickname}}({{#allParams}}{{paramName}}{{^required}}?{{/required}}: {{{dataType}}}, {{/allParams}}options?: any) {
                return {{classname}}Fp(this.configuration).{{nickname}}({{#allParams}}{{paramName}}, {{/allParams}}options).then((request) => request(this.axios, this.basePath));
                }
        {{/useSingleRequestParameter}}
        {{^-last}}

        {{/-last}}
    {{/operation}}
        }
{{/operations}}
